/* Copyright (C) 2010  Jakob Wills Penzien

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* This is the header file for any functions that deal with encryption */
/* include this header file for sanatizingfun.c */

#ifndef Penguin_Land_h
#define Penguin_Land_h

#include <stdio.h>
#include <gcrypt.h>
#include <sys/cdefs.h>
#include <sys/types.h>
#include <sys/resource.h>
#include <paths.h>
#include <limits.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include "readpassphrase.h"

#define YES 1
#define NO 0

FILE *test; /*sole purpose is to check files */

void tuxfips(void);
int tuxcryptfips(void);
int tuxfips_disp(void);

int aesencodefips(char file1[], char file2[]);
int aesdecodefips(char file1[], char file2[]);

int hmacing(char file2[]);
void iv(gcry_cipher_hd_t handle);
int ivblowfish(gcry_cipher_hd_t handle);
char *charbuf(char *point, long buffsize);
void filestripper(char file[]);

void aesencode(void);
void aesdecode(void);

void blowfishcode(void);
void blowfishdecode(void);

int twofishencode(void);
int twofishdecode(void);

int serpentencode(void);
int serpentdecode(void);

void encode( char *buffer, int);
int codekeyed(void);
int method2(void);

void decode( char *buffer, int);
int decodkeyed(void);
int method1(void);

void spc_sanitize_environment (int preservec, char **preservev);
void spc_sanitize_files(void);
void spc_limit_core(void);

void tux(int cont);
int encrypt_type(void);

int intcheckdisp(void);
int intcheck(void);

typedef char *hash_buffer_key;
typedef char *user_key;

#endif
