
#include "Penguin_Land.h"

#define BUFSIZE 1024

int serpentencode (void) {
    FILE *fh;
    FILE *sh;
    char file1 [300], file2 [300];
    char *buff = 0, *outer = 0, *key = 0, *key2 = 0, *key3 = 0;
    int readsz;
    gcry_cipher_hd_t handle;
    gcry_error_t err = 0;
    err = gcry_cipher_open (&handle, GCRY_CIPHER_SERPENT256, GCRY_CIPHER_MODE_CFB, GCRY_CIPHER_SECURE);
    if (err) {
        fprintf (stderr, "Failure: %s/%s\n", gcry_strsource (err), gcry_strerror (err));
        gcry_cipher_close (handle);
        return 7;
    }
    iv (handle);
    if ((buff = charbuf (buff, BUFSIZE)) == NULL)
        return 7;
    if ((outer = charbuf (outer, BUFSIZE)) == NULL)
        return 7;
    if ((key3 = charbuf (key3, 32)) == NULL)
        return 7;
    if ((key = charbuf (key, 300)) == NULL)
        return 7;
    if ((key2 = charbuf (key2, 300)) == NULL)
        return 7;
    fprintf (stdout, "Please enter filename for the file to be encrypted\n");
    if (fgets (file1, 300, stdin) == NULL)
        printf ("error");
    filestripper (file1);
    if (strcmp (file1, "/0") == 0) {
        fprintf (stdout, "No file entered\n");
        fprintf (stdout, "Please enter filename for the file to be encrypted\n");
        if (fgets (file1, 300, stdin) == NULL)
            printf ("error");
        filestripper (file1);
    }
    if ((test = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "First file does not exist");
        return 7;
    }
    fclose (test);
    fprintf (stdout, "Please enter the second filename\n");
    if (fgets (file2, 300, stdin) == NULL)
        printf ("error");
    filestripper (file2);
    if (strcmp (file2, "/0") == 0) {
        fprintf (stdout, "No file entered\n");
        fprintf (stdout, "Please enter the second filename\n");
        if (fgets (file2, 300, stdin) == NULL)
            printf ("error");
        filestripper (file2);
    }
    if ((test = fopen (file2, "r")) != NULL) {
        fprintf (stdout, "%s already exists.\n", file2);
        fprintf (stdout, "Program aborted\n");
        fclose (test);
        return 7;
    }
    readpassphrase ("Please enter a password 50 characters max: ", key, 300, RPP_REQUIRE_TTY);
    readpassphrase ("Please reenter password: ", key2, 300, RPP_REQUIRE_TTY);
    if ((strcmp (key, key2)) != 0) {
        fprintf (stdout, "Passwords do not match\n");
        readpassphrase ("Please enter a password 50 characters max: ", key, 300, RPP_REQUIRE_TTY);
        readpassphrase ("Please reenter password: ", key2, 300, RPP_REQUIRE_TTY);
        if ((strcmp (key, key2)) != 0) {
            fprintf (stdout, "Passwords do not match\n");
            gcry_free (buff);
            gcry_free (outer);
            gcry_cipher_close (handle);
            return 7;
        }
    }
    gcry_md_hash_buffer (GCRY_MD_SHA256, key3, key, 32);
    err = gcry_cipher_setkey (handle, key3, 32);
    if (err) {
        fprintf (stderr, "Failure: %s/%s\n", gcry_strsource (err), gcry_strerror (err));
        gcry_cipher_close (handle);
        return 7;
    }
    memset (key, 0, strlen (key));
    gcry_free (key);
    fprintf (stdout, "Encoding File.\n");
    if ((fh = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "Error opening the file to be read\n");
        fclose (fh);
        return 7;
    }
    if ((sh = fopen (file2, "wb")) == NULL) {
        fprintf (stdout, "Error opening the file to be wrote to\n");
        fclose (sh);
        fclose (fh);
        return 7;
    }
    while ((readsz = fread (buff, 1, BUFSIZE, fh)) != 0) {
        err = gcry_cipher_encrypt (handle, outer, BUFSIZE, buff, BUFSIZE);
        if (err) {
            fprintf (stderr, "Failure:%s/%s\n", gcry_strsource (err), gcry_strerror (err));
            gcry_free (buff);
            gcry_free (outer);
            remove (file2);
            fclose (sh);
            fclose (fh);
            gcry_cipher_close (handle);
            return 7;
        }
        fwrite (outer, 1, readsz, sh);
        memset (buff, 0, BUFSIZE);
    }
    gcry_cipher_close (handle);
    fclose (fh);
    fclose (sh);
    gcry_free (buff);
    gcry_free (outer);
    gcry_free (key3);
    if (hmacing (file2) != 0) {
        fprintf (stderr, "Error making integrity file\n");
        fprintf (stderr, "trying again.\n");
        if (hmacing (file2) != 0) {
            fprintf (stderr, "Error making integrity file\n");
            fprintf (stderr, "Encrypted file is deleted please run again.");
            remove (file2);
            return 7;
        }
    }
    fprintf (stdout, "File encrypted to file.\n");
    gcry_control (GCRYCTL_TERM_SECMEM);
    return 7;
}

int serpentdecode (void) {
    FILE *fh;
    FILE *sh;
    char file1 [300], file2 [300];
    char *buff = 0, *outer = 0, *key = 0, *key2 = 0, *key3 = 0;
    int readsz;
    gcry_cipher_hd_t handle;
    gcry_error_t err = 0;
    err = gcry_cipher_open (&handle, GCRY_CIPHER_SERPENT256, GCRY_CIPHER_MODE_CFB, GCRY_CIPHER_SECURE);
    if (err) {
        fprintf (stderr, "Failure: %s/%s\n", gcry_strsource (err), gcry_strerror (err));
        gcry_cipher_close (handle);
        return 7;
    }
    iv (handle);
    if ((buff = charbuf (buff, BUFSIZE)) == NULL)
        return 7;
    if ((outer = charbuf (outer, BUFSIZE)) == NULL)
        return 7;
    if ((key3 = charbuf (key3, 32)) == NULL)
        return 7;
    if ((key = charbuf (key, 300)) == NULL)
        return 7;
    if ((key2 = charbuf (key2, 300)) == NULL)
        return 7;
    fprintf (stdout, "Please enter filename for the file to be decrypted\n");
    if (fgets (file1, 300, stdin) == NULL)
        printf ("error");
    filestripper (file1);
    if (strcmp (file1, "/0") == 0) {
        fprintf (stdout, "No file entered");
        fprintf (stdout, "Please enter filename for the file to be decrypted\n");
        if (fgets (file1, 300, stdin) == NULL)
            printf ("error");
        filestripper (file1);
    }
    if ((test = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "First file does not exist\n");
        return 7;
    }
    fclose (test);
    fprintf (stdout, "Please enter the second filename\n");
    if (fgets (file2, 300, stdin) == NULL)
        printf ("error");
    filestripper (file2);
    if (strcmp (file2, "/0") == 0) {
        fprintf (stdout, "No file entered\n");
        fprintf (stdout, "Please enter the second filename\n");
        if (fgets (file2, 300, stdin) == NULL)
            printf ("error");
        filestripper (file2);
    }
    if ((test = fopen (file2, "r")) != NULL) {
        fprintf (stdout, "%s already exists.\n", file2);
        fprintf (stdout, "Program aborted\n");
        fclose (test);
        return 7;
    }
    readpassphrase ("Please enter a password 50 characters max: ", key, 300, RPP_REQUIRE_TTY);
    readpassphrase ("Please reenter password: ", key2, 300, RPP_REQUIRE_TTY);
    if ((strcmp (key, key2)) != 0) {
        fprintf (stdout, "Passwords do not match\n");
        readpassphrase ("Please enter a password 50 characters max: ", key, 300, RPP_REQUIRE_TTY);
        readpassphrase ("Please reenter password: ", key2, 300, RPP_REQUIRE_TTY);
        if ((strcmp (key, key2)) != 0) {
            fprintf (stdout, "Passwords do not match\n");
            gcry_free (buff);
            gcry_free (outer);
            gcry_cipher_close (handle);
            return 7;
        }
    }
    gcry_md_hash_buffer (GCRY_MD_SHA256, key3, key, 32);
    err = gcry_cipher_setkey (handle, key3, 32);
    if (err) {
        fprintf (stderr, "Failure: %s/%s\n", gcry_strsource (err), gcry_strerror (err));
        gcry_cipher_close (handle);
        gcry_free (key3);
        gcry_free (buff);
        gcry_free (outer);
        memset (key, 0, strlen (key));
        return 7;
    }
    memset (key, 0, strlen (key));
    gcry_free (key);
    fprintf (stdout, "Decoding File.\n");
    if ((fh = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "Error opening the file to be read\n");
        fclose (fh);
        gcry_free (key3);
        gcry_free (buff);
        gcry_free (outer);
        return 7;
    }
    if ((sh = fopen (file2, "wb")) == NULL) {
        fprintf (stdout, "Error opening the file to be wrote to\n");
        fclose (sh);
        fclose (fh);
        gcry_free (key3);
        gcry_free (buff);
        gcry_free (outer);
        return 7;
    }
    while ((readsz = fread (buff, 1, BUFSIZE, fh)) != 0) {
        err = gcry_cipher_decrypt (handle, outer, BUFSIZE, buff, BUFSIZE);
        if (err) {
            fprintf (stderr, "Failure:%s/%s\n", gcry_strsource (err), gcry_strerror (err));
            gcry_free (buff);
            gcry_free (outer);
            gcry_free (key3);
            fclose (sh);
            fclose (fh);
            remove (file2);
            gcry_cipher_close (handle);
            return 7;
        }
        fwrite (outer, 1, readsz, sh);
        memset (buff, 0, BUFSIZE);
        memset (outer, 0, BUFSIZE);
    }
    fclose (fh);
    fclose (sh);
    gcry_free (buff);
    gcry_free (outer);
    fprintf (stdout, "File decrypted to file.\n");
    gcry_control (GCRYCTL_TERM_SECMEM);
    return 7;
}

