
#include "Penguin_Land.h"

#define BUFSIZE 1024

void blowfishcode (void) {
    FILE *fh;
    FILE *sh;
    char file1 [300], file2 [300];
    char *key = 0, *key2 = 0, *key3 = 0;
    char *penguins_doing_time = 0, *penguin_jailcell = 0;
    int readsz;
    gcry_cipher_hd_t handle;
    gcry_error_t err = 0;
    err = gcry_cipher_open (&handle, GCRY_CIPHER_BLOWFISH, GCRY_CIPHER_MODE_CFB, GCRY_CIPHER_SECURE);
    if (err) {
        fprintf (stderr, "Failure: %s/%s\n", gcry_strsource (err), gcry_strerror (err));
        gcry_cipher_close (handle);
        return;
    }
    ivblowfish (handle);
    if ((penguins_doing_time = charbuf (penguins_doing_time, BUFSIZE)) == NULL)
        return;
    if ((penguin_jailcell = charbuf (penguin_jailcell, BUFSIZE)) == NULL)
        return;
    if ((key3 = charbuf (key3, 32)) == NULL)
        return;
    if ((key = charbuf (key, 300)) == NULL)
        return;
    if ((key2 = charbuf (key2, 300)) == NULL)
        return;
    fprintf (stdout, "Please enter filename for the file to be encrypted\n");
    if (fgets (file1, 300, stdin) == NULL)
        printf ("error");
    filestripper (file1);
    if (strcmp (file1, "/0") == 0) {
        fprintf (stdout, "No file entered\n");
        fprintf (stdout, "Please enter filename for the file to be encrypted\n");
        if (fgets (file1, 300, stdin) == NULL)
            printf ("error");
        filestripper (file1);
    }
    if ((test = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "First file does not exist\n");
        return;
    }
    fclose (test);
    fprintf (stdout, "Please enter the second filename\n");
    if (fgets (file2, 300, stdin) == NULL)
        printf ("error");
    filestripper (file2);
    if (strcmp (file2, "/0") == 0) {
        fprintf (stdout, "No file entered\n");
        fprintf (stdout, "Please enter the second filename\n");
        if (fgets (file2, 300, stdin) == NULL)
            printf ("error");
        filestripper (file2);
    }
    if ((test = fopen (file2, "r")) != NULL) {
        fprintf (stdout, "%s already exists.\n", file2);
        fprintf (stdout, "Program aborted\n");
        fclose (test);
        return;
    }
    readpassphrase ("Please enter a password 50 characters max: ", key, 300, RPP_REQUIRE_TTY);
    readpassphrase ("Please reenter password: ", key2, 300, RPP_REQUIRE_TTY);
    if ((strcmp (key, key2)) != 0) {
        fprintf (stdout, "Passwords do not match\n");
        readpassphrase ("Please enter a password 50 characters max: ", key, 300, RPP_REQUIRE_TTY);
        readpassphrase ("Please reenter password: ", key2, 300, RPP_REQUIRE_TTY);
        if ((strcmp (key, key2)) != 0) {
            fprintf (stdout, "Passwords do not match\n");
            memset (key, 0, strlen (key));
            gcry_free (key3);
            gcry_free (penguins_doing_time);
            gcry_free (penguin_jailcell);
            gcry_cipher_close (handle);
            return;
        }
    }
    gcry_md_hash_buffer (GCRY_MD_SHA256, key3, key, 32);
    err = gcry_cipher_setkey (handle, key3, 32);
    if (err) {
        fprintf (stderr, "Failure: %s/%s\n", gcry_strsource (err), gcry_strerror (err));
        gcry_free (key3);
        gcry_free (penguins_doing_time);
        gcry_free (penguin_jailcell);
        gcry_cipher_close (handle);
        return;
    }
    gcry_free (key);
    gcry_free (key2);
    fprintf (stdout, "Encoding File.\n");
    if ((fh = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "Error opening the file to be read\n");
        fclose (fh);
        gcry_free (key3);
        gcry_free (penguins_doing_time);
        gcry_free (penguin_jailcell);
        gcry_cipher_close (handle);
        return;
    }
    if ((sh = fopen (file2, "wb")) == NULL) {
        fprintf (stdout, "Error opening the file number 2\n");
        fclose (sh);
        fclose (fh);
        gcry_free (key3);
        gcry_free (penguins_doing_time);
        gcry_free (penguin_jailcell);
        gcry_cipher_close (handle);
        return;
    }
    while ((readsz = fread (penguins_doing_time, 1, BUFSIZE, fh)) != 0) {
        err = gcry_cipher_encrypt (handle, penguin_jailcell, BUFSIZE, penguins_doing_time, BUFSIZE);
        if (err) {
            fprintf (stderr, "Failure:%s/%s\n", gcry_strsource (err), gcry_strerror (err));
            gcry_free (key3);
            gcry_free (penguins_doing_time);
            gcry_free (penguin_jailcell);
            remove (file2);
            fclose (sh);
            fclose (fh);
            gcry_cipher_close (handle);
            return;
        }
        fwrite (penguin_jailcell, 1, readsz, sh);
        memset (penguins_doing_time, 0, BUFSIZE);
    }
    gcry_free (key3);
    gcry_free (penguins_doing_time);
    gcry_free (penguin_jailcell);
    fclose (fh);
    fclose (sh);
    gcry_cipher_close (handle);
    if (hmacing (file2) != 0) {
        fprintf (stderr, "Error making integrity file\n");
        fprintf (stderr, "trying again.\n");
        if (hmacing (file2) != 0) {
            fprintf (stderr, "Error making integrity file\n");
            fprintf (stderr, "Encrypted file is deleted please run again.\n");
            remove (file2);
            return;
        }
    }
    fprintf (stdout, "\nFile encrypted to file.\n");
    gcry_control (GCRYCTL_TERM_SECMEM);
    return;
}

void blowfishdecode (void) {
    FILE *fh;
    FILE *sh;
    char *penguins_doing_time = 0, *penguin_jailcell = 0;
    int readsz;
    char *key = 0, *key2 = 0, *key3 = 0;
    char file1 [300], file2 [300];
    gcry_cipher_hd_t handle;
    gcry_error_t err = 0;
    err = gcry_cipher_open (&handle, GCRY_CIPHER_BLOWFISH, GCRY_CIPHER_MODE_CFB, GCRY_CIPHER_SECURE);
    if (err) {
        fprintf (stderr, "Failure: %s/%s\n", gcry_strsource (err), gcry_strerror (err));
        gcry_cipher_close (handle);
        return;
    }
    ivblowfish (handle);
    if ((penguins_doing_time = charbuf (penguins_doing_time, BUFSIZE)) == NULL)
        return;
    if ((penguin_jailcell = charbuf (penguin_jailcell, BUFSIZE)) == NULL)
        return;
    if ((key3 = charbuf (key3, 32)) == NULL)
        return;
    if ((key = charbuf (key, 300)) == NULL)
        return;
    if ((key2 = charbuf (key2, 300)) == NULL)
        return;
    fprintf (stdout, "Please enter filename for the file to be decrypted\n");
    if (fgets (file1, 300, stdin) == NULL)
        printf ("error");
    filestripper (file1);
    if (strcmp (file1, "/0") == 0) {
        fprintf (stdout, "No file entered\n");
        fprintf (stdout, "Please enter filename for the file to be decrypted\n");
        if (fgets (file1, 300, stdin) == NULL)
            printf ("error");
        filestripper (file1);
    }
    if ((test = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "First file does not exist");
        return;
    }
    fclose (test);
    fprintf (stdout, "Please enter the second filename\n");
    if (fgets (file2, 300, stdin) == NULL)
        printf ("error");
    filestripper (file2);
    if (strcmp (file2, "/0") == 0) {
        fprintf (stdout, "No file entered\n");
        fprintf (stdout, "Please enter the second filename\n");
        if (fgets (file2, 300, stdin) == NULL)
            printf ("error");
        filestripper (file2);
    }
    if ((test = fopen (file2, "r")) != NULL) {
        fprintf (stdout, "%s already exists.\n", file2);
        fprintf (stdout, "Program aborted\n");
        fclose (test);
        return;
    }
    readpassphrase ("Please enter a password 50 characters max: ", key, 300, RPP_REQUIRE_TTY);
    readpassphrase ("Please reenter password: ", key2, 300, RPP_REQUIRE_TTY);
    if ((strcmp (key, key2)) != 0) {
        fprintf (stdout, "Passwords do not match\n");
        readpassphrase ("Please enter a password 50 characters max: ", key, 300, RPP_REQUIRE_TTY);
        readpassphrase ("Please reenter password: ", key2, 300, RPP_REQUIRE_TTY);
        if ((strcmp (key, key2)) != 0) {
            fprintf (stdout, "Passwords do not match\n");
            gcry_free (key3);
            gcry_free (penguins_doing_time);
            gcry_free (penguin_jailcell);
            gcry_cipher_close (handle);
            return;
        }
    }
    gcry_md_hash_buffer (GCRY_MD_SHA256, key3, key, 32);
    err = gcry_cipher_setkey (handle, key3, 32);
    if (err) {
        fprintf (stderr, "Failure: %s/%s\n", gcry_strsource (err), gcry_strerror (err));
        gcry_cipher_close (handle);
        gcry_free (key3);
        gcry_free (penguins_doing_time);
        gcry_free (penguin_jailcell);
        memset (key, 0, strlen (key));
        return;
    }
    fprintf (stdout, "Decoding File.\n");
    if ((fh = fopen (file1, "rb")) == NULL) {
        fprintf (stdout, "Error opening the file to be read\n");
        fclose (fh);
        gcry_free (key3);
        gcry_free (penguins_doing_time);
        gcry_free (penguin_jailcell);
        return;
    }
    if ((sh = fopen (file2, "wb")) == NULL) {
        fprintf (stdout, "Error opening the file to be wrote to\n");
        fclose (sh);
        fclose (fh);
        gcry_free (key3);
        gcry_free (penguins_doing_time);
        gcry_free (penguin_jailcell);
        return;
    }
    while ((readsz = fread (penguins_doing_time, 1, BUFSIZE, fh)) != 0) {
        err = gcry_cipher_decrypt (handle, penguin_jailcell, BUFSIZE, penguins_doing_time, BUFSIZE);
        if (err) {
            fprintf (stderr, "Failure:%s/%s\n", gcry_strsource (err), gcry_strerror (err));
            gcry_free (penguins_doing_time);
            gcry_free (penguin_jailcell);
            gcry_free (key3);
            fclose (sh);
            fclose (fh);
            remove (file2);
            gcry_cipher_close (handle);
            return;
        }
        fwrite (penguin_jailcell, 1, readsz, sh);
        memset (penguins_doing_time, 0, BUFSIZE);
        memset (penguin_jailcell, 0, BUFSIZE);
    }
    fclose (fh);
    fclose (sh);
    gcry_free (penguins_doing_time);
    gcry_free (penguin_jailcell);
    gcry_free (key3);
    fprintf (stdout, "File decrypted to file.\n");
    gcry_control (GCRYCTL_TERM_SECMEM);
    return;
}

