
#include "Penguin_Land.h"

#define BUFSIZE 1024

int hmacing (char file2 []) {
    FILE *fh;
    char *buff = 0;
    int readsz;
    char *key = 0, *key2 = 0;
    int len = gcry_md_get_algo_dlen (GCRY_MD_SHA256);
    int i = 0;
    unsigned  char *mac_key;
    gcry_md_hd_t mac;
    gcry_error_t err = 0;
    if ((buff = charbuf (buff, BUFSIZE)) == NULL)
        return 7;
    if ((key = charbuf (key, 300)) == NULL)
        return 7;
    if ((key2 = charbuf (key2, 300)) == NULL)
        return 7;
    if ((fh = fopen (file2, "rb")) == NULL) {
        fprintf (stdout, "Error opening file for HMACing");
        fclose (fh);
        gcry_free (buff);
        return 7;
    }
    err = gcry_md_open (&mac, GCRY_MD_SHA256, GCRY_MD_FLAG_SECURE | GCRY_MD_FLAG_HMAC);
    if (err) {
        fprintf (stderr, "Failure:%s/%s\n", gcry_strsource (err), gcry_strerror (err));
        gcry_free (buff);
        fclose (fh);
        gcry_md_close (mac);
        return 7;
    }
    readpassphrase ("Please enter a HMAC password 50 characters max: ", key, 300, RPP_REQUIRE_TTY);
    readpassphrase ("Please reenter password:", key2, 300, RPP_REQUIRE_TTY);
    if ((strcmp (key, key2)) != 0) {
        fprintf (stdout, "Passwords do not match\n");
        fprintf (stdout, "Passwords do not match\n");
        fprintf (stdout, "Still not long enough bye bye\n");
        gcry_free (buff);
        memset (key, 0, strlen (key));
        gcry_free (key);
        gcry_md_close (mac);
        return 7;
    }
    err = gcry_md_setkey (mac, key, strlen (key));
    if (err) {
        fprintf (stderr, "Failure:%s/%s\n", gcry_strsource (err), gcry_strerror (err));
        gcry_free (buff);
        fclose (fh);
        gcry_md_close (mac);
        return 7;
    }
    memset (key, 0, strlen (key));
    while ((readsz = fread (buff, 1, BUFSIZE, fh)) != 0) {
        gcry_md_write (mac, buff, BUFSIZE);
    }
    mac_key = gcry_md_read (mac, GCRY_MD_SHA256);
    fclose (fh);
    char hmac [10] = "hmac.txt";
    if ((fh = fopen (hmac, "wb")) == NULL) {
        fprintf (stdout, "error opening hmac.txt");
        gcry_free (buff);
        fclose (fh);
        gcry_md_close (mac);
        return 7;
    }
    for (i = 0; i < len; i++) {
        fprintf (fh, "%x", mac_key [i]);
    }
    fclose (fh);
    gcry_md_close (mac);
    gcry_free (buff);
    return 0;
}

